#ifndef TABLE_H
#define TABLE_H

#include<stddef.h>

#define RESIZERATIO (.90)
size_t resize(size_t size,int additions,int deletions);

#include "entry.h"

#include "hashtypes.h"

#ifndef BASE_T
#define BASE_T
typedef union tablebase {
      entry_t closed;
      synonym_t * open;
} base_t;
#endif

#ifndef PARAM_T
#define PARAM_T
typedef union tableparam {
 	 hash_fn hash;
         struct closedparam closed;
} param_t;
#endif

#ifndef PTR_T
#define PTR_T
typedef union tableptr {
        struct closedptr closed;
	struct openptr open;
} ptr_t;
#endif

#ifndef TYPE_T
#define TYPE_T
typedef int type_t;
#endif

#ifndef TABLE_T
#define TABLE_T
typedef struct table {
	type_t type;
	base_t base;
	size_t size;
	param_t param;
	ptr_t ptr;
	int count[4];
} * table_t;
#endif

#define count(table) (table->count[0])
#define additions(table) (table->count[1])
#define deletions(table) (table->count[2])

#include"hash_fn.h"

#define COLLISIONMAX (100)

int hashes;

table_t hashnew(type_t type,int about,param_t param);
void hashdispose(table_t table);
entry_t hashlookup(table_t table,key_t key);
table_t hashadd(table_t table,entry_t entry);
table_t hashremove(table_t table,key_t key);
entry_t hashget(table_t table,get_t get);
table_t *hashresize(table_t *table,size_t newsize);
#define hashnewsize(table) ((table->type & CLOSED) ? resize((size_t)(table->size * table->param.closed.occupancy),table->count[1],table->count[2]) : resize(table->size,table->count[1],table->count[2]))

#define collisions(table) (table->count[0] - table->count[3])
#define usage(table) (((double)(1 + table->count[3]) / (1 + table->count[0])))

#endif
